#include "libusart.h"

volatile unsigned char usart_count;
volatile unsigned char usart_work;

/*------------------------------------------------------------------------------
 *
 *	USART 初期設定
 *
 */
void initUsart() {
}

/*------------------------------------------------------------------------------
 *
 *	USART 送信処理
 *
 *		2400bps: 416.6us, 9600bps: 104.2us, 
 *
 */
void transmitUsart(unsigned char c) {
						usart_work = c;
	__asm
		BANKSEL	USART_PORT		;							BANKSEL	USART_PORT
		bcf	USART_PORT, TX_BIT	;							RES		TX_BIT, (USART_PORT)			; 104   スタートビット設定(LOW)
		nop				;							NOP										; 001
		BANKSEL	_usart_count		;							BANKSEL	_usart_count					; 002
		movlw	8			;							LD		A, 8							; 003
		movwf	_usart_count		;							LD		(_usart_count), A				; 004
transUsart1:	movlw	29			;			transUsart1:	LD		A, 29							;       29 x 3 + 6 = 93us
		PAGESEL	__waitS			;							PAGESEL	__waitS
		call	__waitS			;							CALL	__waitS							; 097                   の時間待ち
		PAGESEL	$			;							PAGESEL $
		nop				;							NOP										; 098
		BANKSEL	_usart_work		;							BANKSEL	_usart_work						; 099
		rrf	_usart_work, F		;							RR		(_usart_work)					; 100   [rs232cWork] >> [C]
		btfss	STATUS, C		;							SKIP	C								; 101
		BANKSEL	USART_PORT		;							BANKSEL	USART_PORT						; 102
		bcf	USART_PORT, TX_BIT	;							RES		TX_BIT, (USART_PORT)			; 103
		btfsc	STATUS, C		;							SKIP	NC								; 104   databit設定(HIGH/LOW)
		bsf	USART_PORT, TX_BIT	;							SET		TX_BIT, (USART_PORT)			; 001
		decfsz	_usart_count, F		
		goto	transUsart1		;							DJNZ	(_usart_count), transUsart1		; 002,003,(004)
						;	
		movlw	31			;							LD		A, 31							;       31 x 3 + 6 = 99us
		PAGESEL	__waitS			;							PAGESEL	__waitS
		call	__waitS			;							CALL	__waitS							; 102                   の時間待ち
		PAGESEL	$			;							PAGESEL $
		BANKSEL	USART_PORT		;							BANKSEL	USART_PORT						; 103
		bsf	USART_PORT, TX_BIT	;							SET		TX_BIT, (USART_PORT)			; 104   ストップビット設定(HIGH)
						;	
		movlw	30			;							LD		A, 30							;       30 x 3 + 6 = 96us
		PAGESEL	__waitS			;							PAGESEL	__waitS
		call	__waitS			;							CALL	__waitS							; 096                   の時間待ち
		PAGESEL	$			;							PAGESEL $
		return				;							RET										; 097,098
	__endasm;
}

/*------------------------------------------------------------------------------
 *
 *	USART 受信処理
 *
 *		未実装
 *
 */
unsigned char receiveUsart() {					// データ受信までブロックされる

	unsigned char recv;

	recv = 0;

	return(recv);
}

unsigned char receiveUsartNb() {				// ノンブロック

	unsigned char recv;

	recv = 0;

	return(recv);
}

